//+------------------------------------------------------------------+
//|                                     TSSv1.1.mq4 8 May 2007       |
//|   Copyright  2007,Pip2,Isto,jam,Oleg77, pips4life, WHTenn       |
//|                                                                  |
//+------------------------------------------------------------------+
/* This indicator is based on T3MA, now called OT3MAV3_1 set at period 4 and
Volume Factor 1.5. and places arrows at peaks/\ and valleys\/ and Alarms at
Buy and Sell points.   Started by Pip2 and enhanced by jam, isto and Oleg77*/
#include <stderror.mqh>
#include <stdlib.mqh>
#property copyright ""
#property link      ""
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Yellow
#property indicator_color2 Magenta


extern bool   Alarmset    = true;
extern bool   alarm2Mail  = false;
extern bool   displayComment = true; // Default is to display comment
extern int    period      = 4;
extern double volfac      = 1.5;
extern string T3MA_Name   = "OT3MAV3_1";
extern int    arrowSize   = 2;
extern string str1="Enter P0 and P1 for slope";
extern int    P0          = 0;
extern int    P1          = 1;


double        upbuffer[];
double        dnbuffer[];
double        ax[];
int           sep,ba,sa;//b=Buy thresh s=Sell thresh.
static int    alarmBar;  // keeps the bar where alarm has been fired
bool          _up, _dn;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
  if(arrowSize < 1)
    arrowSize = 1;
  if(arrowSize > 5)
    arrowSize = 5;
//---- 1 additional buffer is used for T3MA.
  IndicatorBuffers(3);

//---- drawing settings
  IndicatorDigits(Digits+2);
  SetIndexStyle(0,DRAW_ARROW,3,2);
  SetIndexArrow(0,233);//This is buy signal
  SetIndexStyle(1,DRAW_ARROW,3,2);
  SetIndexArrow(1,234);
  SetIndexStyle(2, DRAW_NONE);

//---- 3 indicator buffers mapping
  SetIndexBuffer(0, upbuffer);
  SetIndexBuffer(1, dnbuffer);
  SetIndexBuffer(2, ax);

//---- name for DataWindow and indicator subwindow label
  IndicatorShortName("TSSv1.1");
  SetIndexLabel(0,"Buy ");
  SetIndexLabel(1,"Sell ");
  SetIndexLabel(2,NULL);

//---- if not values
  SetIndexEmptyValue(0,0.0);
  SetIndexEmptyValue(1,0.0);
  SetIndexEmptyValue(2,0.0);

//---- others
  if(Symbol()=="EURUSD"){sep=4;}
  if(Symbol()=="USDCHF"){sep=3;}
  if(Symbol()=="USDJPY"){sep=3;}
  if(Symbol()=="GBPUSD"){sep=3;}
  if(Symbol()=="EURJPY"){sep=20;}
  if(Symbol()=="GBPJPY"){sep=12;}
  if(Symbol()=="AUDUSD"){sep=3;}
  if(Symbol()=="USDCAD"){sep=12;}

//---- alart has been never fired yet
  alarmBar = -1;  
  return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()   {     return(0);   }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start(){ 

  int i, counted_bars=IndicatorCounted();
  if(counted_bars<0)  { return(-1);  }
//---- last counted bar will be recounted
  if(counted_bars>0) { counted_bars--; }
//  if(counted_bars == 0) { return(0);  } /* nothing to do - there is no ticks */
  int limit=Bars-counted_bars;

  for(i=0; i<limit; i++)                  /*---- T3MA counted in the 1st additional buffer */
    ax[i]=iCustom(NULL,0,T3MA_Name,period,volfac,0,i);

  for(i=0; i<limit; i++)
  {
if(counted_bars>0)
{
}
    if(ax[i]-ax[i+1]<0 && ax[i+1]-ax[i+2]>0)     { _dn=true; } else { _dn=false; }
    if((ax[i]-ax[i+1])>0 && (ax[i+1]-ax[i+2])<0) { _up=true; } else { _up=false; }
//---- sell signal
    if( _dn && dnbuffer[i] == 0 )  {  dnbuffer[i] = High[i]+(sep*Point);  }    /* srote value only of is not has been stored already */
    if( !_dn && dnbuffer[i] != 0 && i==0 )  { dnbuffer[i] = 0;  } /* remove false signal */
//---- buy signal
    if( _up && upbuffer[i] == 0)   {  upbuffer[i] = Low[i]-(sep*Point);   }
    if( !_up && upbuffer[i] != 0 && i==0 )  { upbuffer[i] = 0;  }
  } // end for
  if(counted_bars>0)
    doAlarm(upbuffer[0], dnbuffer[0]);
//----  
  if (displayComment) {
  setComment();
  } else {
    Comment(""); // This is necessary to blank out the old comment.
  }

  return(0);
}
//+------------------------------------------------------------------+
//| Custom function - send a mail message for each generated signal  |
//+------------------------------------------------------------------+
void SendMsg(string subj, string msg)
{
  if(alarm2Mail == false) { return; }
  int check;
  msg =StringConcatenate(TimeToStr(TimeLocal(), TIME_DATE), " ", TimeToStr(TimeLocal(), TIME_MINUTES), " ", Symbol()," ",Period()) + msg;
  SendMail(subj, msg);
  check=GetLastError();
  if(check!=ERR_NO_ERROR) 
  {
    Print("subject: ", subj, "; body: ", msg);
    Print("Cannot send message, error: ",ErrorDescription(check));
  }
}
//+------------------------------------------------------------------+
//        Alarm section                                              +
//+------------------------------------------------------------------+
// if buffer has been set and
// if this is another bar than the bar alarm has been fired for the last time
void doAlarm(double _uBuf=0, double _dBuf=0)
{
  if( !Alarmset )               { return; } /*  alarm not desired */
  if( alarmBar >= Bars )        { return; } /* alart has not been fired already */

  if(_uBuf == 0 && _dBuf == 0)  { return; } /* no signal to alarm*/

  RefreshRates(); // This updates Bid/Ask prices.

  Print("_uBuf: " , _uBuf, "; _dBuf: ", _dBuf);

  if(_uBuf != 0 )  
  {
    Alert (Symbol()," ",Period()," TSSv1.1 >> BUY @ ",Ask);
    SendMsg("Buy signal", "  TSSv1.1  >> BUY");
    alarmBar = Bars;
  }
  if(_dBuf != 0)  
  {
    Alert (Symbol()," ",Period()," TSSv1.1 >> SELL @ ",Bid);
    SendMsg("Sell signal", "  TSSv1.1  >> SELL ");
    alarmBar = Bars;
  }
}
//+---------------------------------------------------------+
//        Comment section                                   +
//+---------------------------------------------------------+
void setComment()
{
  double bx0=iMA(NULL,PERIOD_H4,50,0,MODE_LWMA,PRICE_CLOSE,P0);//PERIOD_H1
  double bx1=iMA(NULL,PERIOD_H4,50,0,MODE_LWMA,PRICE_CLOSE,P1);
  double slope=(bx0-bx1)/Point;

  double cx0=iMA(NULL,PERIOD_D1,50,0,MODE_LWMA,PRICE_CLOSE,P0);//PERIOD_H1
  double cx1=iMA(NULL,PERIOD_D1,50,0,MODE_LWMA,PRICE_CLOSE,P1);
  double slope2=(cx0-cx1)/Point;

  Comment("SLOPE PIPS PER PERIOD_H4 = ",slope," AT P0=",P0," & P1=",P1,
          "\n\nSLOPE PIPS PER PERIOD_D1 = ",slope2," AT P0=",P0," & P1=",P1);
}
//+---------------------------------------------------------+

